/*
 * framebuffer user space tests
 *
 *
 */

//#define RGB(r, g, b) ((unsigned long)(((r) << 16) | ((g) << 8) | (b)))

// Header files einlesen
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/fb.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <stdio.h>

main() {
	
	struct fb_fix_screeninfo fixinfo;
	struct fb_var_screeninfo varinfo;
	int row, column;
	unsigned int i;
		
	// Framebuffer Device ffen und Info auslesen
	int fd = open("/dev/fb2", O_RDWR);
	
	ioctl(fd, FBIOGET_VSCREENINFO, &varinfo);
	ioctl(fd, FBIOGET_FSCREENINFO, &fixinfo);
/*
FBIOGET_VSCREENINFO
FBIOPUT_VSCREENINFO
FBIOGET_FSCRENNINFO
FBIOPUTCMAP
FBIOGETCMAP
FBIOPAN_DISPLAY

FBIO_CURSOR
FBIOGET_CON2FBMAP
FBIOPUT_CON2FBMAP
FBIOBLANK
*/

	printf("fb_var_screeninfo@%p",varinfo);
	for(i=0;i<sizeof(struct fb_var_screeninfo);i++){
		if(i%16==0) printf("\n");
		printf("%02x ",*(((char*)&varinfo)+i)  );
	}
	printf("\n");

	printf("fb_fix_screeninfo@%p",fixinfo);
	for(i=0;i<sizeof(struct fb_fix_screeninfo);i++){
		if(i%16==0) printf("\n");
		printf("%02x ",*(((char*)&fixinfo)+i)  );
	}
	
	
	printf("\n");
	
	printf("fb_var_screeninfo:\n");
	printf("bits_per_pixel %d\n",varinfo.bits_per_pixel);
	printf("xres %d\n",varinfo.xres);
	printf("yres %d\n",varinfo.yres);
	printf("xres_virtual %d\n",varinfo.xres_virtual);		
	printf("yres_virtual %d\n",varinfo.yres_virtual);		
	printf("xoffset %d\n",varinfo.xoffset);		
	printf("yoffset %d\n",varinfo.yoffset);		
	printf("grayscale %d\n",varinfo.grayscale);		
	printf("activate %d\n",varinfo.activate);		
	printf("height %d\n",varinfo.height);		
	printf("width %d\n",varinfo.width);		
	printf("pixclock %d\n",varinfo.pixclock);	


	printf("red.offset %d\n",varinfo.red.offset);
	printf("red.length %d\n",varinfo.red.length);
	printf("red.msb_right %d\n",varinfo.red.msb_right);
	printf("green.offset %d\n",varinfo.green.offset);
	printf("green.length %d\n",varinfo.green.length);
	printf("green.msb_right %d\n",varinfo.green.msb_right);
	printf("blue.offset %d\n",varinfo.blue.offset);
	printf("blue.length %d\n",varinfo.blue.length);
	printf("blue.msb_right %d\n",varinfo.blue.msb_right);
	printf("transp.offset %d\n",varinfo.transp.offset);
	printf("transp.length %d\n",varinfo.transp.length);
	printf("transp.msb_right %d\n",varinfo.transp.msb_right);


	printf("\nfb_fix_screeninfo:\n");
	printf("id %s\n",fixinfo.id);
	printf("smem_start 0x%08lX\n",fixinfo.smem_start);
	printf("smem_len 0x%08lX\n",fixinfo.smem_len);
	printf("type %0lX\n",fixinfo.type);
	printf("type_aux %0lX\n",fixinfo.type_aux);
	printf("line_length %d\n",fixinfo.line_length);	
	
	//Gre ermitteln 
	unsigned char *data=(unsigned char*)mmap(0,
			varinfo.xres*varinfo.yres*varinfo.bits_per_pixel/8,
			PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0);

	// Bildschirminhalt zeilenweise bearbeiten
	for(row=0; row<varinfo.yres; row++) {
		for(column=0; column<varinfo.xres; column++) {
			data[column + row * varinfo.xres] = (unsigned short)0x001f;
			       //column%65535;
		};
	};
	
	// Framebuffer aus dem Speicher ausblenden
	munmap(data, varinfo.xres*varinfo.yres*varinfo.bits_per_pixel/8);

	close(fd);
};
